library fallout;

uses kol, data_classes_imagecomplex, data_bmpheader;

const
  BlockSize=20000;
  FT_ARCHIVE=$0001;
  FT_IMAGECOMPLEX = $0008;
  FT_IMAGECOMPLEXCUSTOMPALETTE  = $0010;
  INFO_1='   ';

var
  FData,FTemp: PStream;
  FRMPalette: TBMPPalette;
  DefaultPalette: array[0..767] of Byte=(
$FF,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,
$FF,$FF,$FF,$FD,$FD,$FD,$F0,$F0,$F0,$E1,$E1,$E1,
$D2,$D2,$D2,$C5,$C5,$C5,$B3,$B3,$B3,$9E,$9E,$9E,
$8D,$8D,$8D,$72,$72,$72,$50,$50,$50,$3B,$3B,$3B,
$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FD,$FD,$FF,
$F0,$F0,$FF,$E1,$E1,$FD,$D2,$D2,$F3,$C1,$C1,$E5,
$AE,$AE,$D6,$9E,$9E,$CA,$87,$87,$B8,$72,$72,$A4,
$59,$59,$93,$46,$46,$79,$22,$22,$59,$01,$01,$3B,
$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FD,$FD,
$FF,$F0,$F0,$FD,$E1,$E1,$F3,$D2,$D2,$E5,$C1,$C1,
$D6,$AE,$AE,$CA,$9E,$9E,$B8,$87,$87,$A4,$72,$72,
$93,$59,$59,$79,$46,$46,$59,$22,$22,$3B,$01,$01,
$FF,$FD,$FF,$F6,$AE,$FF,$AE,$46,$B8,$8D,$12,$93,
$6A,$00,$72,$46,$01,$50,$46,$00,$46,$22,$00,$2F,
$FF,$FF,$FF,$CE,$FF,$FF,$00,$FF,$FF,$2F,$FF,$FF,
$50,$EC,$FF,$62,$DA,$F3,$46,$CA,$E1,$22,$B8,$CE,
$01,$A4,$BD,$00,$8D,$A4,$00,$72,$8D,$00,$50,$6A,
$00,$22,$3B,$EC,$FF,$FF,$D6,$FF,$FF,$C1,$FF,$E9,
$A9,$E9,$CA,$8D,$CA,$A9,$6A,$A4,$80,$3B,$72,$50,
$99,$AE,$C1,$6A,$8D,$9E,$3B,$62,$72,$99,$CA,$B8,
$3B,$CA,$C1,$50,$B8,$C1,$46,$AE,$AE,$46,$87,$93,
$3B,$62,$72,$EC,$FA,$EC,$CA,$E5,$CA,$A4,$CE,$A4,
$80,$B8,$80,$A4,$A4,$72,$8D,$93,$62,$79,$87,$50,
$59,$79,$3B,$46,$62,$2F,$22,$50,$12,$01,$3B,$01,
$22,$62,$22,$00,$46,$01,$00,$2F,$00,$00,$12,$00,
$00,$00,$00,$EC,$EC,$DE,$E9,$E5,$CA,$E5,$DA,$B3,
$E1,$CE,$99,$DE,$BD,$80,$DE,$A4,$62,$CE,$93,$59,
$BD,$87,$50,$A9,$72,$3B,$93,$62,$2F,$80,$50,$22,
$F3,$F3,$EC,$B8,$8D,$72,$A4,$A4,$99,$D6,$B8,$A4,
$99,$80,$72,$FF,$FF,$FF,$E9,$F3,$FA,$CE,$E1,$F0,
$AE,$CE,$E5,$93,$B8,$DA,$6A,$A4,$CE,$46,$8D,$C1,
$12,$79,$B3,$00,$62,$A4,$FF,$FF,$FF,$FD,$FD,$FF,
$E9,$E9,$FF,$CE,$CE,$FF,$B3,$B3,$FF,$8D,$8D,$FF,
$62,$62,$FF,$00,$00,$FF,$00,$00,$FF,$00,$00,$FF,
$00,$00,$F6,$00,$00,$E1,$00,$00,$C5,$00,$00,$A4,
$00,$00,$80,$FF,$FF,$FF,$E5,$FF,$FF,$CA,$FF,$FF,
$AE,$FA,$FF,$8D,$EC,$FF,$59,$E5,$FF,$12,$DA,$FF,
$00,$CE,$FF,$00,$BD,$FF,$00,$AE,$FF,$00,$99,$F3,
$00,$87,$D6,$00,$6A,$B8,$00,$46,$93,$00,$22,$62,
$F3,$FF,$FF,$CA,$FD,$FF,$B3,$F0,$FF,$9E,$E1,$FF,
$87,$D2,$FA,$6A,$C5,$EC,$50,$B3,$DE,$2F,$A4,$CE,
$12,$93,$C1,$00,$80,$AE,$00,$6A,$99,$00,$50,$80,
$00,$3B,$6A,$FF,$FF,$FF,$E9,$FF,$FF,$CE,$FA,$FF,
$B3,$E1,$FF,$93,$C5,$FD,$72,$A9,$F0,$59,$93,$E1,
$3B,$79,$D6,$22,$59,$CA,$01,$3B,$BD,$00,$12,$A9,
$00,$00,$8D,$00,$00,$79,$FF,$FF,$FF,$FF,$FF,$FF,
$F0,$FF,$FF,$D6,$FD,$FF,$BD,$F0,$FF,$A9,$E5,$FF,
$9E,$D2,$FF,$8D,$C1,$FF,$80,$AE,$F6,$72,$99,$E1,
$62,$80,$CA,$46,$62,$AE,$2F,$46,$8D,$12,$22,$72,
$B3,$FF,$B3,$12,$E9,$12,$00,$F3,$00,$8D,$99,$99,
$00,$BD,$00,$D6,$DE,$DE,$2F,$2F,$2F,$72,$99,$B8,
$3B,$50,$62,$AE,$C1,$DE,$50,$72,$8D,$00,$00,$00,
$79,$79,$79,$BD,$C5,$BD,$CA,$D6,$CA,$DA,$E5,$DA,
$E5,$F3,$E5,$AE,$B8,$A4,$B8,$C1,$AE,$00,$FF,$79,
$00,$FF,$72,$01,$FF,$6A,$12,$E5,$62,$22,$C5,$50,
$FF,$FF,$FF,$FF,$FF,$FF,$DA,$FF,$FF,$99,$CE,$E9,
$79,$A4,$B8,$46,$80,$99,$2F,$50,$6A,$00,$01,$22,
$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,
$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,
$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,
$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,
$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,
$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,
$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF);

function SwapWord(Value: Word): Word;
var
  b1,b2: Word;
begin
  b1:=(Value and $FF00) shr 8;
  b2:=(Value and $00FF) shl 8;
  Result:=b1 or b2;
end;

function SwapLongInt(Value: LongInt): LongInt;
var
  b1,b2,b3,b4: LongInt;
begin
  b1:=(Value and $FF000000) shr 24;
  b2:=(Value and $00FF0000) shr 8;
  b3:=(Value and $0000FF00) shl 8;
  b4:=(Value and $000000FF) shl 26;
  Result:=b1 or b2 or b3 or b4;
end;

{      }
function BuildStr(s: string; c: char; n: LongInt): string;
var
  t: string;
begin
  if Length(s)=n then
  begin
    BuildStr:=s;
    Exit;
  end;
  t:=s;
  While Length(t)<n do t:=c+t;
  BuildStr:=t;
end;

procedure GetPluginInfo(var Title,Version,GameName,FilterGroupName,Filters,Extentions,Comments: PChar);
begin
  Title:=PChar('Fallout I,II Plugin');
  Version:=PChar('v1.01');
  GameName:=PChar('Fallout I,II');
  FilterGroupName:=PChar('Fallout I,II (*.frm)');
  Filters:=PChar('*.frm');
  Extentions:=PChar('FRM');
  Comments:=PChar('   FRM');
end;

function GetFileInfo(fName: PChar): Word;
var
  fStr,Extention: string;
begin
  fStr:=string(fName);
  Extention:=UpperCase(Copy(fStr,DelimiterLast(fStr,'.')+1,3));
  if Extention='FRM' then Result:=FT_IMAGECOMPLEXCUSTOMPALETTE;
end;

// ID 
function GetPluginID: Integer;
begin
  Result:=$0008;
end;

function GetFileAutoload(fName: PChar): Boolean;
var
  fStr,Extention: string;
begin
  fStr:=string(fName);
  Extention:=UpperCase(Copy(fStr,DelimiterLast(fStr,'.')+1,3));
  if Extention='FRM' then Result:=True;
end;

procedure GetImageComplex(fName, fPalName: PChar; var fImageComplex: TImageComplex; fForm,fLabel,fProgressBar: PControl);
var
  i,j,z,SavePosition: LongInt;
  TotalSprites: Word;
  Buffer: array[1..800]of byte;
  fWidth,fHeight: Word;
  fDataSize: LongInt;
  Add: Byte;
  fOnlyName,fStr,Extention: string;
begin
  if Length(string(fPalName))=0 then
  for i:=0 to 255 do
  begin
    FRMPalette[i].R:=DefaultPalette[i*3];
    FRMPalette[i].G:=DefaultPalette[i*3+1];
    FRMPalette[i].B:=DefaultPalette[i*3+2];
    FRMPalette[i].F:=$00;
  end else LoadPalette(string(fPalName),False,FRMPalette);
  fForm.Show;
  fLabel.Caption:='  ...';
  fProgressBar.Progress:=0;
  fForm.Update;
  // 
  BmpID[1]:='B';
  BmpID[2]:='M';
  BMPHeader._C1:=$00000436;
  BMPHeader._C2:=$00000028;
  BMPHeader._C3:=$0001;
  BMPHeader._C4:=$0008;
  BMPHeader._H2:=$00;
  BMPHeader._H3:=$00;
  FData:=NewReadFileStream(fName);
  fStr:=string(fName);
  fOnlyName:=ExtractFileName(fStr);
  fOnlyName:=Copy(fOnlyName,1,Pos('.',fOnlyName)-1);
  Extention:=UpperCase(Copy(fStr,DelimiterLast(fStr,'.')+1,3));
  FData.Seek($08,spBegin);
  FData.Read(TotalSprites,2);
  TotalSprites:=SwapWord(TotalSprites);
  for i:=1 to TotalSprites do fImageComplex.Add;
  FData.Seek($3E,spBegin);
  SavePosition:=FData.Position;
  for i:=1 to TotalSprites do
  begin
    fImageComplex.Items[i-1].Name:=Copy(ExtractFileName(string(fName)),1,Pos('.',ExtractFileName(string(fName)))-1)+Int2Digs(i-1,3)+'.bmp';
    FData.Seek(SavePosition,spBegin);
    FData.Read(fWidth,2);
    FData.Read(fHeight,2);
    FData.Read(fDataSize,4);
    fWidth:=SwapWord(fWidth);
    fHeight:=SwapWord(fHeight);
    fDataSize:=SwapLongInt(fDataSize);
    FTemp:=NewMemoryStream;
    BMPHeader.x:=fWidth;
    BMPHeader.y:=fHeight;
    BMPheader.DataSize1:=BMPHeader.x*BMPHeader.y;
    BMPheader.DataSize2:=BMPHeader.x*BMPHeader.y;
    BMPHeader.FullSize:=BMPHeader.DataSize1+$436;
    BMPHeader._H3:=BMPHeader.FullSize-$36;
    FTemp.Write(bmpID,2);
    FTemp.Write(BMPHeader,SizeOf(BMPHeader));
    FTemp.Write(FRMPalette,1024);
    Add:=Round(Int((4*(1-(Frac(fWidth/4))))));
    if Add=4 then Add:=0;
    for z:=1 to fHeight do
    begin
      FData.Seek(SavePosition+12+(fHeight-z)*fWidth,spBegin);
      Stream2Stream(FTemp,FData,fWidth);
      if Add>0 then FTemp.Write(Buffer,Add);
    end;
    FTemp.Seek(0,spBegin);
    fImageComplex.Items[i-1].LoadImageFromStream(fTemp);
    FTemp.Free;
    SavePosition:=SavePosition+8+fDataSize+4;
    fProgressBar.Progress:=Round(Int(100*(i/TotalSprites)));
  end;
  FData.Free;
  fForm.Hide;
end;

exports
  GetPluginInfo,
  GetFileInfo,
  GetFileAutoload,
  GetPluginID,
  GetImageComplex;

begin
end.
